/******************************************************************************
 * $Id: gfx_texture.cc,v 1.10 2006/10/10 04:14:55 devel Exp $
 * @file
 * @author	Jim E. Brooks  http://www.jimbrooks.org
 * @brief	Texture (generic, gfxsys-neutral).
 *//*
 * LEGAL:	COPYRIGHT (C) 2004 JIM E. BROOKS
 *          THIS SOURCE CODE IS RELEASED UNDER THE TERMS
 *          OF THE GNU GENERAL PUBLIC LICENSE (GPL).
 ******************************************************************************/

#define GFX_TEXTURE_CC 1
#include "gfx.hh"
#include "gfx_misc.hh"
#include "gfx_gfxsys.hh"
#include "gfx_texture.hh"
namespace gfx {

/*****************************************************************************
 * TexCoord2 operator<().  Needed by SharedVal/STL.
 *****************************************************************************/
bool
operator<( TexCoord2& a, TexCoord2& b )
{
	RETURN_LT_TRUE_GT_FALSE( a.x, b.x )
	RETURN_LT_TRUE_GT_FALSE( a.y, b.y )
	return false; // equal
}

/*****************************************************************************
 * Texture2 operator<().  Needed by SharedVal/STL.
 *****************************************************************************/
bool
operator<( Texture2& a, Texture2& b )
{
	return a.mId < b.mId;
}

} // namespace gfx
