/*****************************************************************************
 * $Id: mod_pony_stats.cc,v 1.1 2006/11/24 21:56:58 devel Exp $
 * @file
 * @author	Jim E. Brooks  http://www.jimbrooks.org
 * @brief	Statistics.
 *//*
 * LEGAL:	COPYRIGHT (C) 2006 JIM E. BROOKS
 *          THIS SOURCE CODE IS RELEASED UNDER THE TERMS
 *          OF THE GNU GENERAL PUBLIC LICENSE (GPL).
 *****************************************************************************/

#if STATS
#define MOD_PONY_STATS_CC 1
#include "mod_pony_common.hh"
#include "gfx_stream.hh"

/*****************************************************************************
 * Stats constructor.
 *****************************************************************************/
ModulePonyStats::ModulePonyStats( void )
{
	mTracers				= 0;
	mLandQuadsDrawn			= 0;
	mLandQuadsDrawnTextured	= 0;
	mHills					= 0;
	mHillsDrawn				= 0;
	mTrees					= 0;
	mTreesDrawn				= 0;
	mLakes					= 0;
	mLakesDrawn				= 0;
}

/*****************************************************************************
 * Clear some stats prior to drawing.
 *****************************************************************************/
void
ModulePonyStats::PreDrawViews( void )
{
	// Only some stats members need resetting.
	mLandQuadsDrawn			= 0;
	mLandQuadsDrawnTextured	= 0;
	mHillsDrawn				= 0;
	mTreesDrawn				= 0;
	mLakesDrawn				= 0;
}

/*****************************************************************************
 * operator<<(ModulePonyStats)
 *****************************************************************************/
ostream&
operator<<( ostream& strm, const ModulePonyStats& o )
{
    strm << "Statistics: \n"
         << "  land quads drawn           = " << o.mLandQuadsDrawn				<< '\n'
         << "  land quads drawn/textured  = " << o.mLandQuadsDrawnTextured		<< '\n'
         << "  hills                      = " << o.mHills						<< '\n'
         << "  hills drawn                = " << o.mHillsDrawn					<< '\n'
         << "  trees                      = " << o.mTrees						<< '\n'
         << "  trees drawn                = " << o.mTreesDrawn					<< '\n'
         << "  lakes                      = " << o.mLakes						<< '\n'
         << "  lakes drawn                = " << o.mLakesDrawn					<< '\n'
         << "[1] Count is inflated by SharedVal storing two copies (key,val)"; // << '\n'
    return strm;
}

#endif // STATS
